program WinProg;

uses
  Strings,Windows;

const
  AppName    = 'WinProg';
  AppCaption = 'Hello world';

function WindowProc(Window: HWnd; AMessage, WParam,
                    LParam: Longint): Longint; stdcall; export;
var
  dc    : HDC;
  ps    : PaintStruct;
  ARect : Rect;
begin
  WindowProc := 0;
  case AMessage of
    wm_paint:
      begin
        dc := BeginPaint(Window,@ps);
        GetClientRect(Window,@ARect);
        DrawText(dc,'Hello world by Free Pascal',-1,@ARect,
                 DT_SINGLELINE or DT_CENTER or DT_VCENTER);
        EndPaint(Window,ps);
        Exit;
      end;
    wm_Destroy:
      begin
        PostQuitMessage(0);
        Exit;
      end;
  end;
  WindowProc := DefWindowProc(Window, AMessage, WParam, LParam);
end;

{Registruojam lango klas}
function WinRegister: Boolean;
var
  WindowClass: WndClass;
begin
  WindowClass.Style         := cs_hRedraw or cs_vRedraw;
  WindowClass.lpfnWndProc   := WndProc(@WindowProc);
  WindowClass.cbClsExtra    := 0;
  WindowClass.cbWndExtra    := 0;
  WindowClass.hInstance     := System.MainInstance;
  WindowClass.hIcon         := LoadIcon(0, idi_Application);
  WindowClass.hCursor       := LoadCursor(0, idc_Arrow);
  WindowClass.hbrBackground := GetStockObject(WHITE_BRUSH);
  WindowClass.lpszMenuName  := nil;
  WindowClass.lpszClassName := AppName;
  Result                    := RegisterClass(WindowClass) <> 0;
end;

{Sukuriam lango klas}
function WinCreate: HWnd;
var
  hWindow: HWnd;
begin
  hWindow := CreateWindow(AppName,AppCaption,
              ws_OverlappedWindow, cw_UseDefault, cw_UseDefault,
              cw_UseDefault, cw_UseDefault, 0, 0, System.MainInstance, nil);
  if hWindow <> 0 then
    begin
      ShowWindow(hWindow, CmdShow);
      UpdateWindow(hWindow);
    end;
  Result := hWindow;
end;

{pagrindin programos dalis}
var
  AMessage : Msg;
  hWindow  : HWnd;
begin
  if not WinRegister then
    begin
      MessageBox(0,'Register failed',nil,mb_Ok);
      Exit;
    end;
  hWindow := WinCreate;
  if LongInt(hWindow) = 0 then
    begin
      MessageBox(0, 'WinCreate failed', nil, mb_Ok);
      Exit;
    end;
  while GetMessage(@AMessage,0,0,0) do
    begin
      TranslateMessage(AMessage);
      DispatchMessage(AMessage);
    end;
  Halt(AMessage.wParam);
end.



